local _, L = ...;

function MiraMod_OnLoad()

	-- Register events
	MiraMod:RegisterEvent("VARIABLES_LOADED");
	MiraMod:RegisterEvent("RAID_TARGET_UPDATE");
	MiraMod:RegisterEvent("CHAT_MSG_MONSTER_YELL");
	MiraMod:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	
	SlashCmdList["MiraMod"] = MiraMod_OnCommand;
	SLASH_MiraMod1 = "/Miramod";
	SLASH_MiraMod2 = "/miramod";	
	
	-- Init global variables
	UpdateTimeInterval 					= 0.5;
	TimeSinceLastUpdate					= 0;
	MiraModTextDisplay 					= nil;
	SoundDir 							= nil;

	-- Singdragosa Stuff
	oldraid_symbol 						= 0;
	Phase2_IceBlockCounter 				= 0;
	Phase2 								= false;
		
	-- Special timers
	
	    SpecialTimersEnd				= {};
		SpecialTimersMsg				= {};
		SpecialTimersSnd				= {};
	
end

function MiraMod_OnCommand(arg)

	local str = L[arg];
	DEFAULT_CHAT_FRAME:AddMessage("L["..arg.."] = "..str);
	
	if(arg=="combat") then
		
		for za=0,CombatCount-1 do
		
			if(CombatSource[za] ~= nil and CombatSpellName[za] ~= nil) then
				
				local msg = "CombatSource["..za.."] = "..CombatSource[za]..", Spell["..za.."] = "..CombatSpellName[za];
				DEFAULT_CHAT_FRAME:AddMessage(msg);

			else
			
				local msg = "CombatSource["..za.."] or, Spell["..za.."] is nil";
				DEFAULT_CHAT_FRAME:AddMessage(msg);
				
			end
		
		end
	end
	
	if(arg=="debuff") then
		
		for za=0,DebuffCount-1 do
		
			if(DebuffListNames[za] ~= nil) then
		
				local msg = "DebuffListNames["..za.."] = "..DebuffListNames[za];
				DEFAULT_CHAT_FRAME:AddMessage(msg);
			
			else

				local msg = "DebuffListNames["..za.."] = is nil";
				DEFAULT_CHAT_FRAME:AddMessage(msg);
			
			end
		
		end	
	
	end

end

function MiraMod_OnVariablesLoaded()

	MiraModTextDisplay = _G["MiraModTextDisplay"];

	MiraModTextDisplay:Show();
	MiraModTextDisplay:SetFadeDuration(1);
	MiraModTextDisplay:SetTimeVisible(2);
	
	if(SoundDir == nil) then
		SoundDir = "Interface\\AddOns\\MiraMod\\Sounds\\en";
	end
		
	SoundDir = SoundDir .. "\\";
	
	-- Debuff-Scanner

		-- Debuff List
		DebuffListNames					= {};	-- List of names of the debuff
		DebuffStates					= {};	-- State of the debuff true = active, false = not active
		DebuffListAddSound				= {};	-- Played soundfile when debuff is detected
		DebuffListAddTextMsg			= {};  	-- Displayed text message
		DebuffListRemoveSound			= {};	-- Played soundfile when debuff is removed
		DebuffListRemoveTextMsg			= {};  	-- Displayed text message
		DebuffScanInGroup				= {}; 	-- True if this debuff has to be searched in the group, to find special debuffs like blackout
		DebuffYellAddText				= {};	-- Text which is yelled when debuff is detected
		DebuffYellRemoveText			= {};	-- Text which is yelled when debuff is removed
		
		DebuffCountdown					= {}; 	-- Used for countdown
		DebuffCountdownPos				= {};	-- Position for countdown
		
		DebuffCount						= 27;
		
		-- Set the init state to false
		local za = 0;
		for za=0,DebuffCount-1 do
			DebuffStates[za] 		= false;
			DebuffCountdown[za] 	= 0;
			DebuffCountdownPos[za] 	= 0;
			DebuffScanInGroup[za]	= false;
		end

		-- Nekrotische Seuche (Lich King, ICC)
		DebuffListNames[0]				= L["Necrotic Plague"];
		DebuffListAddSound[0]			= "seuche.mp3";
		DebuffListAddTextMsg[0]			= L["Plague"];
		
		-- Feurige Einscherung (Halion, Rubinsanktum)
		DebuffListNames[1]				= L["Halion_Fiery_Combustion"];
		DebuffListAddSound[1]			= "lauf.mp3";
		DebuffListAddTextMsg[1]			= L["Halion_Fiery_Combustion_Add"];
		DebuffListRemoveTextMsg[1]		= L["Halion_Fiery_Combustion_Rem"];

		-- Seelenverzehrung (Halion, Rubinsanktum)
		DebuffListNames[2]				= L["Halion_Soul_Consumption"];
		DebuffListAddSound[2]			= "lauf.mp3";
		DebuffListAddTextMsg[2]			= L["Halion_Soul_Consumption_Add"];
		DebuffListRemoveTextMsg[2]		= L["Halion_Soul_Consumption_Rem"];
		
		-- Schattengefngnis (Blutprinzen, ICC)
		DebuffListNames[3]				= L["BloodCouncil_Shadow_Prison"];
		DebuffListRemoveTextMsg[3]		= L["BloodCouncil_Shadow_Prison_Rem"];
		DebuffListRemoveSound[3]		= "verbindungweg.mp3";
		
		-- Entfesselte Seuche (Prof. Hero, ICC)
		DebuffListNames[4]				= L["Putricide_Unbound_Plague"];
		DebuffListAddSound[4]			= "seuche.mp3";
		DebuffListAddTextMsg[4]			= L["Putricide_Unbound_Plague_Add"];
		DebuffListRemoveTextMsg[4]		= L["Putricide_Unbound_Plague_Rem"];
		DebuffListRemoveSound[4]		= "verbindungweg.mp3";
		DebuffCountdown[4]				= 10;
		
		-- Seuchenkrankheit (Prof. Hero, ICC)
		DebuffListNames[5]				= L["Putricide_Plague_Sickness"];
		DebuffListAddSound[5]			= "lauf.mp3";
		DebuffListAddTextMsg[5]			= L["Putricide_Plague_Sickness_Add"];
		DebuffListRemoveTextMsg[5]		= L["Putricide_Plague_Sickness_Rem"];
		DebuffListRemoveSound[5]		= "verbindungweg.mp3";
		
		-- Entfesselte Magie (Sindragosa, ICC)
		DebuffListNames[6]				= L["Sindragosa_Unleashed_Magic"];
		DebuffListAddSound[6]			= "lauf.mp3";
		DebuffListAddTextMsg[6]			= L["Sindragosa_Unleashed_Magic_Add"];	
		DebuffListRemoveTextMsg[6]		= L["Sindragosa_Unleashed_Magic_Rem"];
		DebuffListRemoveSound[6]		= "verbindungweg.mp3";
		DebuffCountdown[6]				= 28;
		
		-- Evolution (Corla, Botin des Zwielichts, Schwarzfelshhlen)
		DebuffListNames[7]				= L["Corla_Evolution"];
		DebuffListRemoveTextMsg[7]		= L["Corla_Evolution_Rem"];
		DebuffListRemoveSound[7]		= "verbindungweg.mp3";
		
		-- Umhllende Magie (Theralion & Valiona, Bastion des Zwielichtes)
		DebuffListNames[8]				= L["Valiona_Engulfing_Magic"];
		DebuffListAddSound[8]			= "lauf.mp3";
		DebuffListAddTextMsg[8]			= L["Valiona_Engulfing_Magic_Add"];
		DebuffListRemoveTextMsg[8]		= L["Valiona_Engulfing_Magic_Rem"];
		DebuffListRemoveSound[8]		= "verbindungweg.mp3";
		
		-- Blackout (Theralion & Valiona, Bastion des Zwielichtes)
		DebuffListNames[9]				= "Blackout";
		DebuffListAddSound[9]			= "hinlauf.mp3";
		DebuffListAddTextMsg[9]			= ">> Blackout, zusammen laufen <<";
		DebuffListRemoveTextMsg[9]		= ">> Blackout weg, verteilen <<";
		DebuffListRemoveSound[9]		= "verbindungweg.mp3";
		DebuffScanInGroup[9]			= true;
		
		-- Zwielichtmeteorit (Theralion & Valiona, Bastion des Zwielichtes)
		DebuffListNames[10]				= L["Valiona_Twilight_Meteorite"];
		DebuffListAddSound[10]			= "hinlauf.mp3";
		DebuffListAddTextMsg[10]		= L["Valiona_Twilight_Meteorite_Add"];
		DebuffListRemoveTextMsg[10]		= L["Valiona_Twilight_Meteorite_Rem"];
		DebuffListRemoveSound[10]		= "verbindungweg.mp3";

		-- Wasserdurchtrnkt (Rat der Aszendentfrsten, Bastion des Zwielichtes)
		DebuffListNames[11]				= L["Feludius_Waterlogged"];
		DebuffListAddSound[11]			= "hinlauf.mp3";
		DebuffListAddTextMsg[11]		= L["Feludius_Waterlogged_Add"]
		DebuffListRemoveTextMsg[11]		= L["Feludius_Waterlogged_Rem"]
		DebuffListRemoveSound[11]		= "verbindungweg.mp3";
		
		-- Blitzableiter (Rat der Aszendentfrsten, Bastion des Zwielichtes)
		DebuffListNames[12]				= L["Arion_Lightning_Rod"];
		DebuffListAddSound[12]			= "lauf.mp3";
		DebuffListAddTextMsg[12]		= L["Arion_Lightning_Rod_Add"];
		DebuffListRemoveTextMsg[12]		= L["Arion_Lightning_Rod_Rem"];
		DebuffListRemoveSound[12]		= "verbindungweg.mp3";
		
		-- Verehren (Cho'gall, Bastion des Zwielichtes)
		DebuffListNames[13]				= L["Chogall_Worshipping"];
		DebuffListAddSound[13]			= "seuche.mp3";
		DebuffListAddTextMsg[13]		= L["Chogall_Worshipping_Add"];
		DebuffYellAddText[13]			= L["Chogall_Worshipping_Yell_Add"];
		DebuffYellRemoveText[13]   	    = L["Chogall_Worshipping_Yell_Rem"];
		DebuffListRemoveSound[13]		= "verbindungweg.mp3";
		
		-- Zielerfassung (Omnotronverteidigungssystem, Pechschwingenabstieg)
		DebuffListNames[14]				= L["Omnotron_Acquiring_Target"];
		DebuffListAddSound[14]			= "lauf.mp3";
		DebuffListAddTextMsg[14]		= L["Omnotron_Acquiring_Target_Add"];
		DebuffListRemoveTextMsg[14]		= L["Omnotron_Acquiring_Target_Rem"];
		DebuffListRemoveSound[14]		= "verbindungweg.mp3";
		DebuffYellAddText[14]			= L["Omnotron_Acquiring_Target_Yell_Add"];
		DebuffYellRemoveText[14]   	    = L["Omnotron_Acquiring_Target_Yell_Rem"];
		
		-- Todesurteil (Atramedes-Trash, Pechschwingenabstieg)
		DebuffListNames[15]				= L["Atramedes_Execution_Sentence"];
		DebuffListAddSound[15]			= "seuche.mp3";
		DebuffListAddTextMsg[15]		= L["Atramedes_Execution_Sentence_Add"];
		DebuffListRemoveTextMsg[15]		= L["Atramedes_Execution_Sentence_Rem"];
		DebuffListRemoveSound[15]		= "verbindungweg.mp3";
		DebuffYellAddText[15]			= L["Atramedes_Execution_Sentence_Yell_Add"];
		DebuffYellRemoveText[15]   	    = L["Atramedes_Execution_Sentence_Yell_Rem"];
				
		-- Kugelgefngnis (Hallen des Urspungs Trash)
		DebuffListNames[16]				= L["BubbleBound"];
		DebuffListAddSound[16]			= "seuche.mp3";
		DebuffListAddTextMsg[16]		= L["BubbleBound_Add"];
		DebuffListRemoveTextMsg[16]		= L["BubbleBound_Rem"];
		DebuffListRemoveSound[16]		= "verbindungweg.mp3";
		DebuffYellAddText[16]			= L["BubbleBound_Yell_Add"];
		DebuffYellRemoveText[16]   	    = L["BubbleBound_Yell_Rem"];
		
		-- Schattenvortex (Burg Schattenfang Trash)
		DebuffListNames[17]				= L["Shadowvortex"];
		DebuffListAddSound[17]			= "lauf.mp3";
		DebuffListAddTextMsg[17]		= L["Shadowvortex_Add"];
		DebuffListRemoveTextMsg[17]		= L["Shadowvortex_Rem"];
		DebuffListRemoveSound[17]		= "verbindungweg.mp3";
			
		-- Dunkler Teich (Halfus Trash, Bastion des Zwielichtes)
		DebuffListNames[18]				= L["Halfus_DarkPool"];
		DebuffListAddSound[18]			= "lauf.mp3";
		DebuffListAddTextMsg[18]		= L["Halfus_DarkPool_Add"];
		DebuffListRemoveTextMsg[18]		= L["Halfus_DarkPool_Rem"];
		DebuffListRemoveSound[18]		= "verbindungweg.mp3";
		
		-- Verzehrende Flammen (Maloriak, Pechschwingenabstieg)
		DebuffListNames[19]				= L["Maloriak_Flames"];
		DebuffListAddSound[19]			= "lauf.mp3";
		DebuffListAddTextMsg[19]		= L["Maloriak_Flames_Add"];
		DebuffListRemoveTextMsg[19]		= L["Maloriak_Flames_Rem"];
		DebuffListRemoveSound[19]		= "verbindungweg.mp3";
		
		-- Blitzeis (Maloriak, Pechschwingenabstieg)
		DebuffListNames[20]				= L["Maloriak_Freeze"];
		DebuffListAddSound[20]			= "seuche.mp3";
		DebuffListAddTextMsg[20]		= L["Maloriak_Freeze_Add"];
		DebuffListRemoveTextMsg[20]		= L["Maloriak_Freeze_Rem"];	
		DebuffListRemoveSound[20]		= "verbindungweg.mp3";
		DebuffYellAddText[20]			= L["Maloriak_Freeze_Yell_Add"];
		DebuffYellRemoveText[20]   	    = L["Maloriak_Freeze_Yell_Rem"];
		
		-- Entkrftender Schleim (Maloriak, Pechschwingenabstieg)
		DebuffListNames[21]				= L["Maloriak_Slime"];
		DebuffListAddSound[21]			= "seuche.mp3";
		DebuffListAddTextMsg[21]		= L["Maloriak_Slime_Add"];
		DebuffListRemoveTextMsg[21]		= L["Maloriak_Slime_Rem"];
		DebuffListRemoveSound[21]		= "verbindungweg.mp3";
		DebuffCountdown[21]				= 13;
		
		-- Fixieren (Omnotronverteidigungssystem, Pechschwingenabstieg)
		DebuffListNames[22]				= L["Omnotron_Fixate"];
		DebuffListAddSound[22]			= "lauf.mp3";
		DebuffListAddTextMsg[22]		= L["Omnotron_Fixate_Add"];
		DebuffListRemoveTextMsg[22]		= L["Omnotron_Fixate_Rem"];
		DebuffListRemoveSound[22]		= "verbindungweg.mp3";
		
		-- Wirbelnde Winde (Rat der Aszendentfrsten, Bastion des Zwielichts)
		DebuffListNames[23]				= L["Arion_Winds"];
		DebuffListAddSound[23]			= "luftbuff.mp3";
		DebuffListAddTextMsg[23]		= L["Arion_Winds_Add"];
		
		-- Geerdet (Rat der Aszendentfrsten, Bastion des Zwielichts)
		DebuffListNames[24]				= L["Terrastra_Grounded"];
		DebuffListAddSound[24]			= "erdbuff.mp3";
		DebuffListAddTextMsg[24]		= L["Terrastra_Grounded_Add"];
		
		-- Blitzableiter (Omnotronverteidigungssystem, Pechschwingenabstieg)
		DebuffListNames[25]				= L["Omnotron_Lightning_Conductor"];
		DebuffListAddSound[25]			= "lauf.mp3";
		DebuffListAddTextMsg[25]		= L["Omnotron_Lightning_Conductor_Add"];
		DebuffListRemoveTextMsg[25]		= L["Omnotron_Lightning_Conductor_Rem"];
		DebuffListRemoveSound[25]		= "verbindungweg.mp3";		
		
		-- Verderbnis: Krankheit (Cho'gall, Bastion des Zwielichtes)
		DebuffListNames[26]				= L["Chogall_Corruption_Sickness"];
		DebuffListAddSound[26]			= "lauf.mp3";
		DebuffListAddTextMsg[26]		= L["Chogall_Corruption_Sickness_Add"];
		DebuffYellAddText[26]			= L["Chogall_Corruption_Sickness_Yell_Add"];
				
		-- Test
		--DebuffListNames[26]			= L["Weakened Soul"];
		--DebuffListAddSound[26]		= "seuche.mp3";
		--DebuffListAddTextMsg[26]		= L["Weakened Soul Get"];
		--DebuffListRemoveTextMsg[26]	= L["Weakened Soul Rem"];
		--DebuffListRemoveSound[26]		= "verbindungweg.mp3";
		--DebuffCountdown[26]			= 13;		
					
	-- Combatlog Scanner
	
		CombatSource					= {};	-- Sourcename
		CombatActionType				= {};	-- can be SPELL_CAST_SUCCESS, SPELL_AURA_APPLIED, SPELL_AURA_REMOVED
		CombatSpellId					= {};	-- Id of the spell, if knowen
		CombatSpellName					= {};	-- Name of the spell
		CombatSound						= {};	-- Sound which is played when event is fired
		CombatTextMsg					= {};	-- Text messages which is displayed
		CombatFunction					= {};	-- Function to be executed
	
		CombatCount						= 10;
		
		-- Verschlingende Flammen (Valiona, Boss 3 Grim Bartol & Boss 2 Bastion des Zwielichts)
		CombatSource[0]					= L["Valiona"];
		CombatActionType[0]				= "SPELL_CAST_START";
		CombatSpellName[0]				= L["Valiona_Flames"];
		CombatSound[0]					= "lauf.mp3";
		CombatTextMsg[0]				= L["Valiona_Flames_Msg"];
		
		-- Statische Aufladung (Asaad, Vortex Gipfel)
		CombatSource[1]					= L["Asaad"];
		CombatActionType[1]				= "SPELL_CAST_START";
		CombatSpellName[1]				= L["Asaad_Static_Cling"];
		CombatSound[1]					= "seuche.mp3";
		CombatTextMsg[1]				= L["Asaad_Static_Cling_Msg"];
		
		-- Arkaner Sturm (Maloriak, Pechschwingenabstieg)
		CombatSource[2]					= L["Maloriak"];
		CombatActionType[2]				= "SPELL_CAST_SUCCESS";
		CombatSpellName[2]				= L["Maloriak_Storm"];
		CombatSound[2]					= "unterbrechen.mp3";
		CombatTextMsg[2]				= L["Maloriak_Storm_Msg"];
		
		-- Fehde (Schimaeron, Pechschwingenabstieg)
		CombatSource[3]					= L["Chimaeron"];
		CombatActionType[3]				= "SPELL_CAST_SUCCESS";
		CombatSpellId[3]				= 88872;
		CombatSpellName[3]				= L["Chimaeron_Feud"];
		CombatSound[3]					= "hinlauf.mp3";
		CombatTextMsg[3]				= L["Chimaeron_Feud_Msg"];
		
		-- Doppelangriff (Schimaeron, Pechschwingenabstieg)
		CombatSource[4]					= L["Chimaeron"];
		CombatActionType[4]				= "SPELL_AURA_APPLIED";
		CombatSpellId[4]				= 88826;
		CombatSpellName[4]				= L["Chimaeron_DoubleAttack"];
		CombatSound[4]					= "doppelangriff.mp3";
		CombatTextMsg[4]				= L["Chimaeron_DoubleAttack_Msg"];
		
		-- Sterblichkeit (Schimaeron, Pechschwingenabstieg)
		CombatSource[5]					= L["Chimaeron"];
		CombatActionType[5]				= "SPELL_CAST_SUCCESS";
		CombatSpellId[5]				= 82890;
		CombatSpellName[5]				= L["Chimaeron_Mortality"];
		CombatSound[5]					= "phase2.mp3";
		CombatTextMsg[5]				= L["Phase2"];
		
		-- Beben (Rat der Aszendentfrsten, Bastion des Zwielichts)
		CombatSource[6]					= L["Terrastra"];
		CombatActionType[6]				= "SPELL_CAST_START";
		CombatSpellId[6]				= 83565;
		CombatSpellName[6]				= L["Terrastra_Quake"];
		CombatFunction[6]				= MiraMod_OnTerrastraCastBeben;
		
		-- Donnerschock (Rat der Aszendentfrsten, Bastion des Zwielichts)
		CombatSource[7]					= L["Arion"];
		CombatActionType[7]				= "SPELL_CAST_START";
		CombatSpellId[7]				= 83067;
		CombatSpellName[7]				= L["Arion_Thundershock"];
		CombatFunction[7]				= MiraMod_OnArionCastDonnerschock;
		
		-- Summon Corrupting Adherent (Cho'gall, Bastion des Zwielichts)
		CombatSource[8]					= L["Chogall"];
		CombatActionType[8]				= "SPELL_CAST_START";
		CombatSpellId[8]				= 81628;
		CombatSpellName[8]				= L["Chogall_Creates_Add"];
		CombatTextMsg[8]				= L["NewAdd"];
		
		-- Corrupting Adherent dies (Cho'gall, Bastion des Zwielichts)
		CombatSource[9]					= L["Chogall_Corrupting_Adherent"];
		CombatActionType[9]				= "UNIT_DIED";
		CombatTextMsg[9]				= L["AddDown"];
		
		-- Test
		--CombatSource[8]					= "Miralu";
		--CombatActionType[8]				= "SPELL_CAST_START";		
		--CombatSpellName[8]				= "Heilung";
		--CombatFunction[8]				= MiraMod_OnArionCastDonnerschock;			

	-- Say hello		
	DEFAULT_CHAT_FRAME:AddMessage(L["StartUpMsg"], 0.5, 0.5, 1.0);
	
end

function MiraMod_OnTerrastraCastBeben()

	table.insert(SpecialTimersEnd, time() + 6);
	table.insert(SpecialTimersMsg, L["TerrastraCastBeben"]);
	table.insert(SpecialTimersSnd, "beben.mp3");
	
end

function MiraMod_OnArionCastDonnerschock()

	table.insert(SpecialTimersEnd, time() + 6);
	table.insert(SpecialTimersMsg, L["ArionCastDonnerschock"]);
	table.insert(SpecialTimersSnd, "donnerschock.mp3");	

end

function MiraMod_OnUpdate(self, elapsed)

	if(MiraModTextDisplay) then

		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed;

		if (TimeSinceLastUpdate > UpdateTimeInterval) then
		
			local numplayers = GetNumRaidMembers();
	
			local za = 0;
			for za=0, DebuffCount-1 do
							
				local Debuff;
				
				if(DebuffScanInGroup[za] == false) then

					if(DebuffListNames[za] ~= nil) then
					
						Debuff = UnitDebuff("player", DebuffListNames[za]);
					
						if(Debuff == nil) then
							Debuff = UnitBuff("player", DebuffListNames[za]);
						end
					
					end	
										
				else
								
					for zb=1,numplayers do
						
						local name = GetRaidRosterInfo(zb);
						
						if(name ~= nil) then
							Debuff = UnitDebuff(name, DebuffListNames[za]);
							if(Debuff ~= nil) then
								break
							end
						end
							
					end
					
				end
				
				if(Debuff) then
								
					if(not DebuffStates[za]) then

						if(DebuffListAddSound[za] ~= nil) then 
							local FileName = SoundDir .. DebuffListAddSound[za];
							PlaySoundFile(FileName, "Master");
						end
						
						if(DebuffListAddTextMsg[za] ~= nil) then
							MiraModTextDisplay:AddMessage(DebuffListAddTextMsg[za], 1.0, 0.32, 0.66);
						end
						
						if(DebuffYellAddText[za] ~= nil) then
							SendChatMessage(DebuffYellAddText[za], "YELL", nil, 0);
						end
					
						DebuffStates[za] = true;

						if(DebuffCountdown[za] > 0) then
							DebuffCountdownPos[za] = DebuffCountdown[za];
						end
						
					end
				end
				
				if(DebuffCountdownPos[za]>UpdateTimeInterval) then					
					
					if(DebuffCountdownPos[za] == 9) then
						PlaySoundFile(SoundDir .. "9.mp3", "Master");
					end
						
					if(DebuffCountdownPos[za] == 8) then
						PlaySoundFile(SoundDir .. "8.mp3", "Master");
					end

					if(DebuffCountdownPos[za] == 7) then
						PlaySoundFile(SoundDir .. "7.mp3", "Master");
					end

					if(DebuffCountdownPos[za] == 6) then
						PlaySoundFile(SoundDir .. "6.mp3", "Master");
					end
					
					if(DebuffCountdownPos[za] == 5) then
						PlaySoundFile(SoundDir .. "5.mp3", "Master");
					end
					
					if(DebuffCountdownPos[za] == 4) then
						PlaySoundFile(SoundDir .. "4.mp3", "Master");
					end

					if(DebuffCountdownPos[za] == 3) then
						PlaySoundFile(SoundDir .. "3.mp3", "Master");
					end
					
					if(DebuffCountdownPos[za] == 2) then
						PlaySoundFile(SoundDir .. "2.mp3", "Master");
					end

					if(DebuffCountdownPos[za] == 1) then
						PlaySoundFile(SoundDir .. "1.mp3", "Master");
					end
					
					DebuffCountdownPos[za] = DebuffCountdownPos[za] - UpdateTimeInterval;
					
				end
				
				if(not Debuff and DebuffStates[za]==true) then
				
					DebuffStates[za] = false;
				
					if(DebuffListRemoveTextMsg[za] ~= nil) then					
						MiraModTextDisplay:AddMessage(DebuffListRemoveTextMsg[za], 0.32, 1.00, 0.32);					
					end
					
					if(DebuffListRemoveSound[za] ~= nil) then
						local FileName = SoundDir .. DebuffListRemoveSound[za];
						PlaySoundFile(FileName, "Master");
					end
					
					if(DebuffYellRemoveText[za] ~= nil) then
						SendChatMessage(DebuffYellRemoveText[za], "YELL", nil, 0);
					end						
					
					if(DebuffCountdownPos[za]>0) then
						DebuffCountdownPos[za] = 0;
					end
					
				end
				
			end
				
			local TimerSize 	= #SpecialTimersEnd;
			local CurrentTime 	= time();
								
			for za=TimerSize,1,-1 do
			
				if(SpecialTimersEnd[za] ~= nil) then 
								
					if(SpecialTimersEnd[za] <= CurrentTime) then
					
						-- Timer ran out
						
						local Msg = SpecialTimersMsg[za];
						local Snd = SpecialTimersSnd[za];
						
						if(Msg ~= nil) then

							MiraModTextDisplay:AddMessage(Msg, 1.0, 1.0, 0.55);		
						
						end
						
						if(Snd ~= nil) then
						
							local FileName = SoundDir .. Snd;
							PlaySoundFile(FileName, "Master");
						
						end
						
					table.remove(SpecialTimersEnd, za);
					table.remove(SpecialTimersMsg, za);
					table.remove(SpecialTimersSnd, za);
					
					end

				end				
			
			end
			
			TimeSinceLastUpdate = 0;
		
		end

	end

end

function MiraMod_OnEvent(self, event, ...)

local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18 = select(1, ...)

	if event == "VARIABLES_LOADED" then
		MiraMod_OnVariablesLoaded();
	end

	if MiraModTextDisplay == nil then
		return;
	end
	
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		
		local za = 0;
		for za=0, CombatCount-1 do
			if CombatSource[za] == arg4 and CombatActionType[za] == arg2 and (CombatSpellId[za] == arg9 or CombatSpellName[za] == arg10) then
		
				if(CombatSound[za] ~= nil) then 
					local FileName = SoundDir .. CombatSound[za];
					PlaySoundFile(FileName, "Master");
				end
				
				if(CombatTextMsg[za] ~= nil) then
					MiraModTextDisplay:AddMessage(CombatTextMsg[za], 1.0, 0.32, 0.66);
				end
				
				if(CombatFunction[za] ~= nil) then
					CombatFunction[za]();
				end
			end
		end
		
	end
	
	if event == "CHAT_MSG_MONSTER_YELL" then
	
		-- Wotlk
		if(arg2 == L["Sindragosa"]) then
		
			-- Airphase
			if(arg1 == L["Sindragosa_AirPhase"]) then
				PlaySoundFile(SoundDir .. "hebtab.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["AirPhase"], 1.0, 0.32, 0.66);
			end
		
			-- Phase 2
			if(arg1 == L["Sindragosa_Phase2"]) then
				Phase2 = true;
				PlaySoundFile(SoundDir .. "phase2.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["Phase2"], 1.0, 0.32, 0.66);
			end
			
			-- Pull
			if(arg1 == L["Sindragosa_Pull"]) then
				Phase2_IceBlockCounter = 0;	
				Phase2 = false;
		
				MiraModTextDisplay:AddMessage(L["Sindragosa_GoodLuck"], 1.0, 1.0, 0.55);
			end
		
		end
		
		-- Cata
		if(arg2 == L["Ozruk"]) then
		
			if(arg1 == L["Ozruk_Reflect"]) then
				PlaySoundFile(SoundDir .. "seuche.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["Ozruk_Reflect_Msg"], 1.0, 0.32, 0.66);
			end
			
		end
		
		if(arg2 == L["Arion"]) then		
			-- Phase 2
			if(arg1 == L["Arion_Phase2"]) then
				PlaySoundFile(SoundDir .. "phase2.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["Phase2"], 1.0, 0.32, 0.66);
			end						
		end
		
		if(arg2 == L["Elementium_Monstrosity"]) then
			-- Phase 3
			if(arg1 == L["Elementium_Monstrosity_Phase3"]) then
				PlaySoundFile(SoundDir .. "phase3.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["Phase3"], 1.0, 0.32, 0.66);
				MiraModTextDisplay:AddMessage(L["10m_Range"], 1.0, 0.32, 0.66);
			end
		end
				
		if(arg2 == L["Atramedes"]) then
		
			-- Flugphase
			if(arg1 == L["Atramedes_AirPhase"]) then
				PlaySoundFile(SoundDir .. "hebtab.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["AirPhase"], 1.0, 0.32, 0.66);
				
				-- Add landing warning here, ground phase will start after 30 secs
				table.insert(SpecialTimersEnd, time() + 25);
				table.insert(SpecialTimersMsg, L["NextPhaseSoon"]);
				table.insert(SpecialTimersSnd, "nextphasesoon.mp3");				
				
				-- Add flame warning here, flame will start after 78 secs
				table.insert(SpecialTimersEnd, time() + 73);
				table.insert(SpecialTimersMsg, L["Atramedes_Flame_Soon_Msg"]);
				table.insert(SpecialTimersSnd, "flammebald.mp3");

				-- Add flyphase warning here, will start after 120 secs
				table.insert(SpecialTimersEnd, time() + 115);
				table.insert(SpecialTimersMsg, L["AirPhase_Soon"]);
				table.insert(SpecialTimersSnd, "flugphasebald.mp3");				
				
			end
			
			-- Sengende Flamme
			if(arg1 == L["Atramedes_Flame"]) then
				PlaySoundFile(SoundDir .. "unterbrechen.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["Atramedes_Flame_Msg"], 1.0, 0.32, 0.66);
			end
			
			-- Pull
			if(arg1 == L["Atramedes_Pull"]) then

				-- Add flame warning here, flame will start after 45 secs
				table.insert(SpecialTimersEnd, time() + 40);
				table.insert(SpecialTimersMsg, L["Atramedes_Flame_Soon_Msg"]);
				table.insert(SpecialTimersSnd, "flammebald.mp3");
				
				-- Add flyphase warning here, will start after 95 secs
				table.insert(SpecialTimersEnd, time() + 90);
				table.insert(SpecialTimersMsg, L["AirPhase_Soon"]);
				table.insert(SpecialTimersSnd, "flugphasebald.mp3");
			
			end
		
		end
		
		if(arg2 == L["Maloriak"]) then
		
			-- Phase 2
			if(arg1 == L["Maloriak_Low_HP_1"] or arg1 == L["Maloriak_Low_HP_2"]) then
				PlaySoundFile(SoundDir .. "phase2.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["Phase2"], 1.0, 0.32, 0.66);
			end
			
			-- Blaue Phase
			if(arg1 == L["Maloriak_Blue_Phase"]) then
				PlaySoundFile(SoundDir .. "blauephase.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["Maloriak_Blue_Phase_Msg"], 0.32, 0.32, 1.00);
				
				table.insert(SpecialTimersEnd, time() + 40);
				table.insert(SpecialTimersMsg, L["NextPhaseSoon"]);
				table.insert(SpecialTimersSnd, "nextphasesoon.mp3");
			end
			
			-- Rote Phase
			if(arg1 == L["Maloriak_Red_Phase"]) then
				PlaySoundFile(SoundDir .. "rotephase.mp3", "Master");
				MiraModTextDisplay:AddMessage(L["Maloriak_Red_Phase_Msg"], 1.0, 0.32, 0.32);
				
				table.insert(SpecialTimersEnd, time() + 40);
				table.insert(SpecialTimersMsg, L["NextPhaseSoon"]);
				table.insert(SpecialTimersSnd, "nextphasesoon.mp3");
			end
			
			-- Grne Phase
			if(arg1 == L["Maloriak_Green_Phase"]) then
				MiraModTextDisplay:AddMessage(L["Maloriak_Green_Phase_Msg"], 0.32, 1.00, 0.32);
				PlaySoundFile(SoundDir .. "gruenephase.mp3", "Master");
				
				table.insert(SpecialTimersEnd, time() + 40);
				table.insert(SpecialTimersMsg, L["NextPhaseSoon"]);
				table.insert(SpecialTimersSnd, "nextphasesoon.mp3");
			end
		
		end
		
		if(arg2 == L["Anshal"] or arg2 == L["Nezir"]) then
		
			-- Pull
			if(arg1 == L["Anshal_Pull"] or arg1 == L["Nezir_Pull"]) then
			
				table.insert(SpecialTimersEnd, time() + 77);
				table.insert(SpecialTimersMsg, L["NextPhaseSoon"]);
				table.insert(SpecialTimersSnd, "nextphasesoon.mp3");
			
			end
		
		end
		
		if(arg2 == L["Rohash"]) then
		
			-- Start von Ultimate
			if(arg1 == L["Rohash_Ultimate"]) then

				table.insert(SpecialTimersEnd, time() + 97);
				table.insert(SpecialTimersMsg, L["NextPhaseSoon"]);
				table.insert(SpecialTimersSnd, "nextphasesoon.mp3");
			
			end
		
		end
		
	end
	
	if event == "RAID_TARGET_UPDATE" then
	
		local subzone	= GetSubZoneText();
			
		if (subzone == L["Sindragosa_Zone"]) then
			
			local index = GetRaidTargetIndex("player");

			local someonehasskull = false;			
				
			if(Phase2 == true) then
				local numplayers = GetNumRaidMembers();
										
				for za=1,numplayers do
					local name = GetRaidRosterInfo(za);
								
					local icon = GetRaidTargetIndex(name);
					
					if(icon) then
						if(icon==8) then
								someonehasskull = true;
								break;
						end
					end
				end
				
				if(someonehasskull == true) then
					Phase2_IceBlockCounter = Phase2_IceBlockCounter+1;
					DEFAULT_CHAT_FRAME:AddMessage("Iceblockcounter: "..Phase2_IceBlockCounter, 0.5, 0.5, 1.0);
				end					
			end
								
			if(index ~= oldraid_symbol) then
			
				local Debuff 	= UnitDebuff("player", L["Sindragosa_FrostBeacon"]);
				local InCombat 	= InCombatLockdown();
				
				-- Should only fire when the debuff is set, to prevent false alarms OR when we're not in combat for test reasons
				if(Debuff or InCombat == nil) then
				
					oldraid_symbol = index;
					
					if(Phase2 == false) then
					
						local InstanceDifficulty = GetInstanceDifficulty();
										
						if(InstanceDifficulty==2 or InstanceDifficulty==4) then
						
							-- 25 man modes
							
							-- vorne links		VIERECK
							if(index == 6) then
								PlaySoundFile(SoundDir .. "vornelinks.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Front_Left"], 1.0, 1.0, 0.55);
							end
							
							-- vorne rechts		MOND
							if(index == 5) then
								PlaySoundFile(SoundDir .. "vornerechts.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Front_Right"], 1.0, 1.0, 0.55);
							end
							
							-- mitte			KREUZ + DIAMANT
							if(index == 7 or index == 3) then
								PlaySoundFile(SoundDir .. "mitte.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Center"], 1.0, 1.0, 0.55);
							end
							
							-- hinten links		DREIECK
							if(index == 4) then
								PlaySoundFile(SoundDir .. "hintenlinks.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Rear_Left"], 1.0, 1.0, 0.55);
							end
							
							-- hinten rechts	KOPF
							if(index == 8) then
								PlaySoundFile(SoundDir .. "hintenrechts.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Rear_Right"], 1.0, 1.0, 0.55);
							end

						end
						
						if(InstanceDifficulty==1 or InstanceDifficulty==3) then
							
							-- 10 man modes
							
							-- vorne links		KREUZ
							if(index == 7) then
								PlaySoundFile(SoundDir .. "vornelinks.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Front_Left"], 1.0, 1.0, 0.55);
							end

							-- vorne rechts		KOPF
							if(index == 8) then
								PlaySoundFile(SoundDir .. "vornerechts.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Front_Right"], 1.0, 1.0, 0.55);
							end					
							
						end
					
					end

					if(Phase2 == true) then
						-- code here for phase 2
						if(index == 8) then
							
							if(Phase2_IceBlockCounter % 2 == 1) then
								PlaySoundFile(SoundDir .. "vornelinks.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Front_Left"], 1.0, 1.0, 0.55);
							end
							
							if(Phase2_IceBlockCounter % 2 == 0) then
								PlaySoundFile(SoundDir .. "vornerechts.mp3", "Master");
								MiraModTextDisplay:AddMessage(L["Sindragosa_Front_Right"], 1.0, 1.0, 0.55);
							end
						
						end

					end
					
				end
				
			else
				oldraid_symbol = 0;
			end
			
		end

	end
	
end